## cppad 2019.02.00.5

=== CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-19 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# =============================================================================
# Some constants
# =============================================================================
# Suppress warnging that WIN32 not defined on cygwin
SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # remove when version below >= 2.8.4
#
# Set the minimum required version of cmake for this project.
# see http://www.cmake.org/pipermail/cmake/2013-January/053213.html
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.4)
#
# https://gitlab.kitware.com/cmake/cmake/issues/17292
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()
#
# cppad_version is used by version.sh to get the version number.
SET(cppad_version "20190200.5")
SET(cppad_url          "http://www.coin-or.org/CppAD" )
SET(cppad_description  "Differentiation of C++ Algorithms" )
#
# Set name of this project and create the variables
# cppad_BINARY_DIR and cppad_SOURCE_DIR.
# project(projectname [CXX] [C] [Java])
PROJECT(cppad)
#
# Add the include sub-directory to the list of C++ preprocessor
# include directories for the entire project.
# include_directories([AFTER|BEFORE] [SYSTEM] dir1 dir2 ...)
INCLUDE_DIRECTORIES( ${cppad_SOURCE_DIR}/include )
#
# =============================================================================
# Some system cmake language extensions
# =============================================================================
# CHECK_CXX_SOURCE_COMPILES(source variable)
# Checks whether the code given in source will compile, link and run and
# return zero status. You can set
# CMAKE_REQUIRED_LIBRARIES, CMAKE_REQUIRED_FLAGS and CMAKE_REQUIRED_INCLUDES
# accordingly if additional libraries or compiler flags are required.
INCLUDE(CheckCXXSourceRuns)

# ============================================================================
# Some local cmake language
# ============================================================================
# join strings together
INCLUDE(cmake/join.cmake)
#
# dos_path_to_unix(dos_path unix_path)
INCLUDE(cmake/dos_path_to_unix.cmake)
#
# add_to_list(variable_list constant_value)
INCLUDE(cmake/add_to_list.cmake)
#
# command_line_arg(variable default type description)
INCLUDE(cmake/command_line_arg.cmake)
#
# optional_package(package description)
INCLUDE(cmake/optional_package.cmake)
#
# check_source_runs(source variable)
INCLUDE(cmake/check_source_runs.cmake)
#
# assert(variable)
INCLUDE(cmake/assert.cmake)
#
# print_variable(variable)
INCLUDE(cmake/print_variable.cmake)
#
# set_compile_flags( program_name debug_which source_list)
INCLUDE(cmake/set_compile_flags.cmake)
# =============================================================================
# command line arguments
# =============================================================================
# cmake_install_datadir
command_line_arg(cmake_install_datadir share STRING
    "directory, below prefix, where cmake installs cppad data files"
)
# -----------------------------------------------------------------------------
# cmake_install_docdir
command_line_arg(cmake_install_docdir NOTFOUND STRING
    "directory, below prefix, where cmake installs cppad documentation files"
)
# -----------------------------------------------------------------------------
# cmake_install_includedirs
command_line_arg(cmake_install_includedirs include STRING
    "directories, below prefix, where cmake installs include files"
)
# -----------------------------------------------------------------------------
# cmake_install_libdirs
command_line_arg(cmake_install_libdirs lib STRING
    "directories, below prefix, where cmake installs library files"
)
# -----------------------------------------------------------------------------
# cppad_prefix
command_line_arg(cppad_prefix /usr PATH
    "cppad install prefix"
)
SET(CMAKE_INSTALL_PREFIX "${cppad_prefix}"
    CACHE PATH "value copied from cppad_prefix" FORCE
)
IF( cmake_install_prefix )
    MESSAGE(FATAL_ERROR
        "cmake_install_prefix has been changed to cppad_prefix"
    )
ENDIF( cmake_install_prefix )
# -----------------------------------------------------------------------------
# cppad_postfix
command_line_arg(cppad_postfix NOTFOUND STRING
    "cppad install postfix"
)
IF( cmake_install_postfix )
    MESSAGE(FATAL_ERROR
        "cmake_install_postfix has been changed to cppad_postfix"
    )
ENDIF( cmake_install_postfix )
# -----------------------------------------------------------------------------
# cppad_cxx_flags
command_line_arg(cppad_cxx_flags "" STRING
    "compile flags used with cppad (besides debug, release, and profile flags)"
)
# -----------------------------------------------------------------------------
# cppad_profile_flag
command_line_arg(cppad_profile_flag NOTFOUND STRING
    "compile flag used to compile and link a profile version of a program"
)
# -----------------------------------------------------------------------------
# All the External package prefixes without warnings
SET(system_include TRUE)
#
# adolc_prefix
optional_package(adolc ${system_include} "adolc install prefix")
#
# colpack_prefix
optional_package(colpack ${system_include} "colpack install prefix")
#
# ipopt_prefix
optional_package(ipopt ${system_include} "ipopt install prefix")
#
# sacado_prefix
optional_package(sacado ${system_include} "sacado install prefix")
#
# eigen_prefix
optional_package(eigen ${system_include} "eigen install prefix")
#
# fadbad_prefix
optional_package(fadbad ${system_include} "fadbad install prefix")
# -----------------------------------------------------------------------------
# cppad_testvector
command_line_arg(cppad_testvector cppad STRING
    "Namespace of vector used for testing, one of: boost, cppad, eigen, std"
)
#
# cppad_max_num_threads
command_line_arg(cppad_max_num_threads 48 STRING
    "maximum number of threads that CppAD can use use"
)
# cppad_sparse_list
IF( cppad_sparse_list )
    MESSAGE(FATAL_ERROR
        "cppad_sparse_list = ${cppad_sparse_list}"
        ": this command line argument has been removed"
    )
ENDIF( cppad_sparse_list )
#
# cppad_tape_id_type
command_line_arg(cppad_tape_id_type "unsigned int" STRING
    "type used to identify different tapes, size must be <= sizeof(size_t)"
)
#
# cppad_tape_addr_type
command_line_arg(cppad_tape_addr_type "unsigned int" STRING
"type used to identify variables on one tape, size must be <= sizeof(size_t)"
)
#
# cppad_debug_which
command_line_arg(cppad_debug_which "debug_all" STRING
    "debug_even, debug_odd, debug_all, or debug_none"
)
# cppad_deprecated
IF( cppad_deprecated )
    MESSAGE(FATAL_ERROR "cppad_deprecated has been removed" )
ENDIF( cppad_deprecated )
# =============================================================================
# colpack_libs, cppad_lib
#
IF( cppad_has_colpack )
    SET( colpack_libs "ColPack" )
    SET( cppad_lib    "cppad_lib" )
ELSE( cppad_has_colpack )
    SET( colpack_libs "" )
    SET( cppad_lib    "" )
ENDIF( cppad_has_colpack )
# =============================================================================
# automated system configuration
# =============================================================================
# CMAKE_CXX_FLAGS
# remove Visual Studio C++ warning level if specified in cppad_cxx_flags
IF ( cppad_cxx_flags MATCHES "/W[0-9]" )
    STRING( REGEX REPLACE "/W[0-9]" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS} )
ENDIF ( cppad_cxx_flags MATCHES "/W[0-9]" )
print_variable(CMAKE_CXX_FLAGS)
# -----------------------------------------------------------------------------
# cppad_abs_includedir, cppad_abs_libdir, cppad_abs_datadir, cppad_abs_docdir
#
# for dir_types = includedirs, libdirs, datadir, docdir
FOREACH(dir_types includedirs libdirs datadir docdir)
    # set dir_type = dir_types with  "dirs" -> "dir"
    STRING(REGEX REPLACE "dirs" "dir" dir_type ${dir_types})
    #
    # set dir_name to first directory in cmake_install_${dir_types}
    SET(dir_name NOTFOUND)
    FOREACH(dir ${cmake_install_${dir_types}})
        IF( NOT dir_name )
            SET(dir_name ${dir})
        ENDIF( NOT dir_name )
    ENDFOREACH(dir ${cmake_install_${dir_types}})
    #
    # set cppad_abs_${dir_type}
    SET(cppad_abs_${dir_type} "${cppad_prefix}/${dir_name}" )
    #
    # check if we need to add a postfix to it
    IF( cppad_postfix )
        SET(cppad_abs_${dir_type} ${cppad_abs_${dir_type}}/${cppad_postfix} )
    ENDIF( cppad_postfix )
ENDFOREACH(dir_types includedirs libdirs datadir docdir)
# -----------------------------------------------------------------------------
# OPENMP_FOUND, OpenMP_CXX_FLAGS
FIND_PACKAGE(OpenMP)
# -----------------------------------------------------------------------------
# boost_prefix
FIND_PACKAGE(Boost)
SET(cppad_has_boost 0)
IF ( Boost_FOUND )
    SET(cppad_has_boost 1)
    #
    # Extract the Boost prefix from Boost_INCLUDE_DIRS
    #
    # convert to using unix directory separator
    dos_path_to_unix("${Boost_INCLUDE_DIRS}" boost_include_dirs)
    #
    # convert to just one directory
    STRING(REGEX REPLACE
        "([^ ]+).*" "\\1"
        boost_include_dir "${boost_include_dirs}"
    )
    #
    # extract part before last backslash
    STRING(REGEX REPLACE
        "([^ ]*)/[^/ ]*" "\\1"
        boost_prefix "${boost_include_dir}"
    )
    print_variable(boost_prefix)
    #
    # add boost include directories
    FOREACH(dir ${cmake_install_includedirs})
        IF( IS_DIRECTORY ${boost_prefix}/${dir} )
            INCLUDE_DIRECTORIES( ${boost_prefix}/${dir} )
            MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
        ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
    ENDFOREACH( dir )
    #
    # add boost link directories
    FOREACH(dir ${cmake_install_libdirs})
        IF( IS_DIRECTORY ${boost_prefix}/${dir} )
            LINK_DIRECTORIES( ${boost_prefix}/${dir} )
            MESSAGE(STATUS "Found ${boost_prefix}/${dir}")
        ENDIF( IS_DIRECTORY ${boost_prefix}/${dir} )
    ENDFOREACH( dir )
ENDIF ( Boost_FOUND )
# -----------------------------------------------------------------------------
# ipopt_LIBRARIES and ipopt_LIBRARY_DIRS
IF( cppad_has_ipopt )
    FIND_PACKAGE(PkgConfig)
    IF( NOT PKG_CONFIG_FOUND )
        MESSAGE(FATAL_ERROR "Using ipopt_prefix but cannot find pkg-config")
    ENDIF( NOT PKG_CONFIG_FOUND )
    #
    # Set the system environment variable PKG_CONFIG_PATH
    FOREACH(dir ${cmake_install_libdirs})
        IF(EXISTS "${ipopt_prefix}/${dir}/pkgconfig/ipopt.pc")
            SET( ENV{PKG_CONFIG_PATH} ${ipopt_prefix}/${dir}/pkgconfig )
        ENDIF(EXISTS "${ipopt_prefix}/${dir}/pkgconfig/ipopt.pc")
    ENDFOREACH(dir)
    #
    # pkg_check_modules(<PREFIX> [REQUIRED] <MODULE> [<MODULE>]*)
    # ipopt_LIBRARIES      ... only the libraries (w/o the '-l')
    # ipopt_LIBRARY_DIRS   ... the paths of the libraries (w/o the '-L')
    pkg_check_modules(ipopt ipopt)
    IF( NOT ipopt_FOUND )
        MESSAGE(FATAL_ERROR
"For all directories dir in cmake_install_libdirs, cannot find the file
    ipopt_prefix/dir/pkgconfig/ipopt.pc
where
    ipopt_prefix = ${ipopt_prefix}
    cmake_install_libdirs = ${cmake_install_libdirs}
"
        )
    ENDIF( NOT ipopt_FOUND )
ENDIF( cppad_has_ipopt )
# =============================================================================
# Currently building tests as normal executables
# =============================================================================
# The CMakeLists.txt file in the specified source directory is processed

=== cppad_ipopt/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------

# Initialize list of tests as empty
SET(check_cppad_ipopt_depends "")

# assert ipopt_prefix is defined
IF ( NOT ipopt_prefix )
    MESSAGE(FATAL_ERROR
        "cppad_ipopt/CMakeLists.txt: ipopt_prefix = ${ipopt_prefix}"
    )
ENDIF ( NOT ipopt_prefix )

# The CMakeLists.txt file in the specified source directory is processed
# before the current input file continues beyond this command.
# add_subdirectory(source_dir [binary_dir] [EXCLUDE_FROM_ALL])
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(example)
ADD_SUBDIRECTORY(speed)
ADD_SUBDIRECTORY(test)

# Add the check_cppad_ipopt target
ADD_CUSTOM_TARGET(check_cppad_ipopt DEPENDS ${check_cppad_ipopt_depends} )
MESSAGE(STATUS "make check_cppad_ipopt: available")

# Change check depends in parent environment
add_to_list(check_depends check_cppad_ipopt)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== cppad_lib/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build and install the cppad_lib shared library
#
# string(REGEX REPLACE <regular_expression>
#        <replace_expression> <output variable>
#        <input> [<input>...])
#
# (year - 2000) dot (remove leading 0 from mmdd) dot (release)
# Note that the dot (release) is optional
# Also name that when mmdd is 0000 get (year - 2000) dot dot (release)
STRING(REGEX REPLACE
    "20([0-9][0-9])0*([0-9]*)([.]?[0-9]*)"
    "\\1.\\2\\3"
    soversion
    ${cppad_version}
)
# In case where mmdd is 0000, dot (release) is present. Convert to
# (year - 2000) dot 0 dot (release)
STRING(REGEX REPLACE
    "([.][.])"
    ".0."
    soversion
    ${soversion}
)
print_variable(soversion)
#
#  add_library(<name> [STATIC | SHARED | MODULE] [EXCLUDE_FROM_ALL]
#   source1 source2 ... sourceN)
# )
SET(source_list cppad_colpack.cpp)
set_compile_flags(cppad_lib "${cppad_debug_which}" "${source_list}" )
ADD_LIBRARY( cppad_lib SHARED ${source_list} )
#
# set_target_properties(target1 target2 ...
# PROPERTIES prop1 value1 prop2 value2 ...)
SET_TARGET_PROPERTIES( cppad_lib PROPERTIES SOVERSION ${soversion} )
#
# install(TARGETS myExe mySharedLib myStaticLib
#   RUNTIME DESTINATION bin
#   LIBRARY DESTINATION lib
#   ARCHIVE DESTINATION lib/static)
INSTALL(TARGETS cppad_lib DESTINATION ${cppad_abs_libdir})

=== introduction/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the introduction/exp_apx directory tests

SET(source_list
    introduction.cpp
    exp_2.cpp
    exp_2.hpp
    exp_2_cppad.cpp
    exp_2_for1.cpp
    exp_2_for2.cpp
    exp_2_rev1.cpp
    exp_2_rev2.cpp
    exp_2_for0.cpp
    exp_eps.cpp
    exp_eps.hpp
    exp_eps_cppad.cpp
    exp_eps_for1.cpp
    exp_eps_for2.cpp
    exp_eps_for0.cpp
    exp_eps_rev1.cpp
    exp_eps_rev2.cpp
)
set_compile_flags( introduction "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( introduction EXCLUDE_FROM_ALL ${source_list} )

# Add this check target
ADD_CUSTOM_TARGET(check_introduction
    introduction
    DEPENDS introduction
)
MESSAGE(STATUS "make check_introduction: available")

# Change check depends in parent environment
add_to_list(check_depends check_introduction)
SET(check_depends "${check_depends}" PARENT_SCOPE)

=== pkgconfig/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Construct cppad.pc from cppad.pc.in; see
# http://people.freedesktop.org/~dbn/pkg-config-guide.html
# -----------------------------------------------------------------------------
#
# Colpack does not have a pkgconfig file. Search for the missing information.
# Note that colpack is linked through cppad_lib, so we only need
# colpack_libdir
SET(colpack_libdir     NOTFOUND)
IF( cppad_has_colpack )
    FOREACH(dir ${cmake_install_libdirs})
        FILE(GLOB file_list "${colpack_prefix}/${dir}/libColPack.*" )
        IF( file_list )
            SET(colpack_libdir "${colpack_prefix}/${dir}")
        ENDIF( file_list )
    ENDFOREACH(dir ${cmake_install_libdirs})
    IF( NOT colpack_libdir )
        MESSAGE(FATAL_ERROR "Cannit find libColPack.* below ${colpack_prefix}")
    ENDIF( NOT colpack_libdir )
ENDIF( cppad_has_colpack )
# -----------------------------------------------------------------------------
# cppad_pkgconfig_requires
# cppad_pkgconfig_requires_uninstalled
#
SET(cppad_pkgconfig_requires             "")
SET(cppad_pkgconfig_requires_uninstalled "")
IF( cppad_has_ipopt )
    SET(cppad_pkgconfig_requires             "ipopt")
    SET(cppad_pkgconfig_requires_uninstalled "ipopt")
ENDIF( cppad_has_ipopt )
# -----------------------------------------------------------------------------
# cppad_pkgconfig_cflags
# cppad_pkgconfig_cflags_uninstalled
#
SET(cppad_pkgconfig_cflags             "-I${cppad_abs_includedir}" )
SET(cppad_pkgconfig_cflags_uninstalled "-I${cppad_SOURCE_DIR}"     )
# ----------------------------------------------------------------------------
# cppad_pkgconfig_libs
# cppad_pkgconfig_libs_uninstalled
#
# default
SET(cppad_pkgconfig_libs             "")
SET(cppad_pkgconfig_libs_uninstalled "")
#
# if have ipopt
IF( cppad_has_ipopt )
    SET(cppad_pkgconfig_libs "-L${cppad_abs_libdir} -lcppad_ipopt" )
    SET(cppad_pkgconfig_libs_uninstalled
        "-L${cppad_BINARY_DIR}/cppad_ipopt/src -lcppad_ipopt"
    )
ENDIF( cppad_has_ipopt)
#
# if have colpack
IF( cppad_has_colpack )
    join(cppad_pkgconfig_libs  " "
        "-L${cppad_abs_libdir} -lcppad_lib"
        "-L${colpack_libdir}   -lColPack"
    )
    join(cppad_pkgconfig_libs_uninstalled " "
        "-L${cppad_BINARY_DIR}/cppad_lib -lcppad_lib"
        "-L${colpack_libdir} -lColPack"
    )
ENDIF( cppad_has_colpack )
#
# if have both colpack and ipopt
IF( cppad_has_colpack AND cppad_has_ipopt )
    join(cppad_pkgconfig_libs " "
        "-L${cppad_abs_libdir} -lcppad_lib -lcppad_ipopt"
        "-L${colpack_libdir} -lColPack"
    )
    join(cppad_pkgconfig_libs_uninstalled " "
        "-L${cppad_BINARY_DIR}/cppad_lib -lcppad_lib"
        "-L${cppad_BINARY_DIR}/cppad_ipopt/src -lcppad_ipopt"
        "-L${colpack_libdir} -lColPack"
    )
ENDIF( cppad_has_colpack AND cppad_has_ipopt )
# ----------------------------------------------------------------------------
#
# Copy a file to another location and modify its contents.
CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/cppad.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
)
CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/cppad-uninstalled.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/cppad-uninstalled.pc
)
# During install copy cppad.pc to datadir and libdir
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
    DESTINATION ${cppad_abs_datadir}/pkgconfig
)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cppad.pc
    DESTINATION ${cppad_abs_libdir}/pkgconfig
)

=== cppad_ipopt/example/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Inherit build type from ../CMakeList.txt

# Local include directories to search (not in package_prefix/include)
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/../src )

# Local link directories to search (not in external packages)
LINK_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR}/../src ${ipopt_LIBRARY_DIRS} )

# add_executable(<name> [WIN32] [MACOSX_BUNDLE] [EXCLUDE_FROM_ALL]
#                 source1 source2 ... sourceN
# )
SET(source_list
    example.cpp
    get_started.cpp
    ode_check.cpp
    ode_check.hpp
    ode_fast_check.cpp
    ode_fast.hpp
    ode_problem.hpp
    ode_run.hpp
    ode_simple_check.cpp
    ode_simple.hpp
)
set_compile_flags( cppad_ipopt_example "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE( cppad_ipopt_example EXCLUDE_FROM_ALL ${source_list} )

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(cppad_ipopt_example
    cppad_ipopt
    ${cppad_lib}
    ${ipopt_LIBRARIES}
    ${colpack_libs}
)

# Add the check_cppad_ipopt_example target
ADD_CUSTOM_TARGET(check_cppad_ipopt_example
    cppad_ipopt_example
    DEPENDS cppad_ipopt_example cppad_ipopt
)
MESSAGE(STATUS "make check_cppad_ipopt_example: available")

# Change check depends in parent environment
add_to_list(check_cppad_ipopt_depends check_cppad_ipopt_example)
SET(check_cppad_ipopt_depends "${check_cppad_ipopt_depends}" PARENT_SCOPE)

=== example/atomic_two/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
#
# eigen_sources and CPPAD_HAS_EIGEN
IF( cppad_has_eigen )
    SET(eigen_sources eigen_mat_inv.cpp eigen_cholesky.cpp eigen_mat_mul.cpp)
ELSE( cppad_has_eigen )
    SET(eigen_sources "")
ENDIF( cppad_has_eigen )
#
SET(source_list
    ${eigen_sources}
    atomic_two.cpp
)
set_compile_flags( example_atomic_two "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_atomic_two EXCLUDE_FROM_ALL ${source_list})
#
# Add the check_example_atomic_two target
ADD_CUSTOM_TARGET(check_example_atomic_two
    example_atomic_two
    DEPENDS example_atomic_two
)
MESSAGE(STATUS "make check_example_atomic_two: available")
#
# add to check check_example_depends in parent environment
add_to_list(check_example_depends check_example_atomic_two)
SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)

=== example/chkpoint_two/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
#
SET(source_list
    chkpoint_two.cpp
    base2ad.cpp
    compare.cpp
    dynamic.cpp
    get_started.cpp
    ode.cpp
)
set_compile_flags( example_chkpoint_two "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_chkpoint_two EXCLUDE_FROM_ALL ${source_list})
#
# Add the check_example_chkpoint_two target
ADD_CUSTOM_TARGET(check_example_chkpoint_two
    example_chkpoint_two
    DEPENDS example_chkpoint_two
)
MESSAGE(STATUS "make check_example_chkpoint_two: available")
#
# add to check check_example_depends in parent environment
add_to_list(check_example_depends check_example_chkpoint_two)
SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)

=== example/ipopt_solve/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the example/ipopt_solve directory tests

# Local link directories to search, as determined by pkg-config for ipopt
LINK_DIRECTORIES( ${ipopt_LIBRARY_DIRS} )
#
SET(source_list
    get_started.cpp
    ipopt_solve.cpp
    ode_inverse.cpp
    retape.cpp
)
set_compile_flags( example_ipopt_solve "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_ipopt_solve EXCLUDE_FROM_ALL ${source_list})
#
# libraries to be linked into the specified target,
# as determined by pkg-config for ipopt
TARGET_LINK_LIBRARIES(example_ipopt_solve
    ${cppad_lib}
    ${ipopt_LIBRARIES}
    ${colpack_libs}
)

# Add the check_example_ipopt_solve target
ADD_CUSTOM_TARGET(check_example_ipopt_solve
    example_ipopt_solve
    DEPENDS example_ipopt_solve
)
MESSAGE(STATUS "make check_example_ipopt_solve: available")

# Change check_example_depends in parent environment
add_to_list(check_example_depends check_example_ipopt_solve)
SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)

=== example/multi_thread/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------

# initialize list as empty
SET(check_example_multi_thread_depends "")

# Define the operation
# CHECK_LIBRARY_EXISTS (LIBRARY FUNCTION LOCATION VARIABLE)
#   LIBRARY  - the name of the library you are looking for
#   FUNCTION - the name of the function
#   LOCATION - location where the library should be found
#   VARIABLE - variable to store the result
INCLUDE(CheckLibraryExists)

# If openmp found, set process its subdirectory
IF ( OPENMP_FOUND )
    # OpenMP_CXX_FLAGS - flags to add to the CXX compiler for OpenMP support
    ADD_SUBDIRECTORY(openmp)
ENDIF ( OPENMP_FOUND )

# If pthreads found, set pthread_lib and pthread_lib_path and process subdir
#
# find_library(<VAR> name1 [path1 path2 ...])
SET(pthread_lib "pthread")
FIND_LIBRARY(pthread_lib_path pthread)
MESSAGE(STATUS "pthread library path = ${pthread_lib_path}")
IF ( pthread_lib_path )
    CHECK_LIBRARY_EXISTS(
        pthread pthread_barrier_wait ${pthread_lib_path} pthread_ok
    )
    IF ( pthread_ok )
        ADD_SUBDIRECTORY(pthread)
    ENDIF ( pthread_ok )
ENDIF ( pthread_lib_path )

# IF we find a boost multi-threadding library, define the corresponding
# bthread_lib, bthread_lib_path, and process the bthread subdirectory.
IF ( Boost_FOUND )
    SET(bthread_lib NOTFOUND)
    FOREACH(idir ${cmake_install_includedirs})
        FOREACH(ldir ${cmake_install_libdirs})
            FOREACH(lname boost_thread-mt boost_thread )
                # abort this search when find a match
                IF( NOT bthread_lib )
                    #
                    SET(CMAKE_REQUIRED_DEFINITIONS "")
                    SET(CMAKE_REQUIRED_INCLUDES  "${boost_prefix}/${idir}")
                    SET(CMAKE_REQUIRED_LIBRARIES "${lname}" )
                    SET(lpath                    "${boost_prefix}/${ldir}" )
                    SET(CMAKE_REQUIRED_FLAGS     "-L${lpath}" )
                    # CHECK_CXX_SOURCE_RUNS(source variable)
                    SET(source "
# include <boost/thread.hpp>
int main(void)
{   boost::barrier wait(1);
    return 0;
}"                  )
                    SET(flag ${idir}_${ldir}_${lname}_ok )
                    STRING( REGEX REPLACE "-" "_" flag ${flag})
                    IF( DEFINED ${flag} )
                        MESSAGE( ERROR
                            "${flag} is defined before expected"
                        )
                    ENDIF( DEFINED ${flag} )
                    CHECK_CXX_SOURCE_RUNS("${source}" ${flag} )
                    IF ( ${flag} )
                        SET(bthread_lib      ${lname} )
                        SET(bthread_lib_path ${lpath} )
                    ENDIF ( ${flag} )
                ENDIF( NOT bthread_lib )
            ENDFOREACH(lname boost_thread boost_thread-mt)
        ENDFOREACH(ldir ${cmake_install_liddirs})
    ENDFOREACH(idir ${cmake_install_includedirs})
    #
    IF( bthread_lib )
        ADD_SUBDIRECTORY(bthread)
        MESSAGE(STATUS
        "boost multi-threading library = ${bthread_lib_path}/${bthread_lib}"
        )
    ELSE( bthread_lib )
        MESSAGE(STATUS "Could not find boost multi-threading library")
    ENDIF( bthread_lib )
ENDIF ( Boost_FOUND )

IF( NOT( "${check_example_multi_thread_depends}" STREQUAL "" ) )
    # check_example_multi_thread
    ADD_CUSTOM_TARGET(check_example_multi_thread DEPENDS ${check_example_multi_thread_depends})
    MESSAGE(STATUS "make check_example_multi_thread: available")

    # Change check depends in parent environment
    add_to_list(check_depends check_example_multi_thread)
    SET(check_depends "${check_depends}" PARENT_SCOPE)
ENDIF( NOT( "${check_example_multi_thread_depends}" STREQUAL "" ) )

=== example/optimize/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-17 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
# Build the example/optimize directory tests
#
#
SET(source_list
    conditional_skip.cpp
    compare_op.cpp
    cumulative_sum.cpp
    forward_active.cpp
    nest_conditional.cpp
    print_for.cpp
    optimize.cpp
    reverse_active.cpp
)
set_compile_flags( example_optimize "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_optimize EXCLUDE_FROM_ALL ${source_list})

# Add the check_example_optimize target
ADD_CUSTOM_TARGET(check_example_optimize
    example_optimize
    DEPENDS example_optimize
)
MESSAGE(STATUS "make check_example_optimize: available")

# add to check check_example_depends in parent environment
add_to_list(check_example_depends check_example_optimize)
SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)

=== example/sparse/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# CppAD: C++ Algorithmic Differentiation: Copyright (C) 2003-18 Bradley M. Bell
#
# CppAD is distributed under the terms of the
#              Eclipse Public License Version 2.0.
#
# This Source Code may also be made available under the following
# Secondary License when the conditions for such availability set forth
# in the Eclipse Public License, Version 2.0 are satisfied:
#       GNU General Public License, Version 2.0 or later.
# -----------------------------------------------------------------------------
#
# BEGIN_SORT_THIS_LINE_PLUS_2
SET(source_list sparse.cpp
    colpack_hes.cpp
    colpack_hessian.cpp
    colpack_jac.cpp
    colpack_jacobian.cpp
    conj_grad.cpp
    dependency.cpp
    for_hes_sparsity.cpp
    for_jac_sparsity.cpp
    for_sparse_hes.cpp
    for_sparse_jac.cpp
    rc_sparsity.cpp
    rev_hes_sparsity.cpp
    rev_jac_sparsity.cpp
    rev_sparse_hes.cpp
    rev_sparse_jac.cpp
    sparse_hes.cpp
    sparse_hessian.cpp
    sparse_jac_for.cpp
    sparse_jacobian.cpp
    sparse_jac_rev.cpp
    sparse_sub_hes.cpp
    sparsity_sub.cpp
    subgraph_hes2jac.cpp
    subgraph_jac_rev.cpp
    subgraph_reverse.cpp
    subgraph_sparsity.cpp
    sub_sparse_hes.cpp
)
# END_SORT_THIS_LINE_MINUS_2

IF( cppad_has_eigen )
    SET(source_list sparse2eigen.cpp ${source_list} )
ENDIF( cppad_has_eigen )

set_compile_flags( example_sparse "${cppad_debug_which}" "${source_list}" )
#
ADD_EXECUTABLE(example_sparse EXCLUDE_FROM_ALL ${source_list})

# List of libraries to be linked into the specified target
TARGET_LINK_LIBRARIES(example_sparse
    ${cppad_lib}
    ${colpack_libs}
)

# Add the check_example_sparse target
ADD_CUSTOM_TARGET(check_example_sparse
    example_sparse
    DEPENDS example_sparse
)
MESSAGE(STATUS "make check_example_sparse: available")

# add to check_example_depends in parent environment
add_to_list(check_example_depends check_example_sparse)
SET(check_example_depends "${check_example_depends}" PARENT_SCOPE)

=== debian/changelog ===
cppad (2019.02.00.5-1) unstable; urgency=medium

  * Set upstream metadata fields: Bug-Submit.
  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 23 Sep 2019 15:24:18 +0100

=== debian/control ===
Source: cppad
Section: devel
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Miles Lubin <miles.lubin@gmail.com>,
           Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 12), cmake, libboost-dev
Standards-Version: 4.4.0
Homepage: https://projects.coin-or.org/CppAD/
Vcs-Git: https://salsa.debian.org/science-team/cppad.git
Vcs-Browser: https://salsa.debian.org/science-team/cppad

Package: cppad
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Automatic Differentiation (AD) of C++ algorithms
 CppAD is a package for automatic differentiation of algorithms
 written in C++.  Given appropriately written C++ code that computes a
 function, CppAD augments it to also compute derivative values.  The
 system uses templates, supports forward and reverse accumulation
 modes, and allows nested derivatives.
 .
 This package contains C++ header files and documentation.
